#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library BCBMM.LIB to both the DLL project and any
//   EXE projects that use the DLL.  This will change the DLL and its calling
//   EXE's to use the BCBMM.DLL as their memory manager.  In these cases,
//   the file BCBMM.DLL should be deployed along with your DLL.
//
//   To avoid using BCBMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//---------------------------------------------------------------------------
#include "mixmaster.h"
#include "qsnymver.h"
#include "nymwizdlgs.h"
#include "nymdecdlgs.h"
#include "nymrptsdlgs.h"
#include "fingerdlgs.h"
USERES("QSnym\QSnym.res");
USEFORM("QSnym\MixDlgs.cpp", MixForm);
USEFORM("QSnym\NymEditDlgs.cpp", NymEditDlg);
USEFORM("QSnym\NymRemsDlgs.cpp", NymRemsDlg);
USEFORM("QSnym\NymRepDlgs.cpp", NymRepDlg);
USEFORM("QSnym\NymDecDlgs.cpp", NymDecDlg);
USEFORM("QSnym\NymWizDlgs.cpp", NymWizDlg);
USEUNIT("QSnym\PGPbuffers.cpp");
USEUNIT("QSnym\Mixmaster.cpp");
USEUNIT("QSnym\PgpFiles.cpp");
USEUNIT("QSnym\pgpmail.cpp");
USEUNIT("QSnym\QSnymVer.cpp");
USEFORM("QSnym\FingerDlgs.cpp", FingerDlg);
USEFORM("QSnym\NymIntrDlgs.cpp", NymIntrDlg);
USEFORM("QSnym\WipeDlgs.cpp", WipeDlg);
USEFORM("QSnym\NymRestPgpDlgs.cpp", NymRestPgpDlg);
USEFORM("QSnym\NymCnclDlgs.cpp", NymCnclDlg);
USEFORM("QSnym\BrokeChnDlgs.cpp", BrokeChnDlg);
USEUNIT("QSnym\Cyberpunk.cpp");
USEFORM("QSnym\NymRptsDlgs.cpp", NymRptsDlg);
USEUNIT("QSnym\Global.cpp");    // has redefined AppExe
USEFORM("QSshared\MsgBoxDlgs.cpp", MsgBoxDialog);
USEFORM("QSshared\HelpDlgs.cpp", HelpDlg);
USEFORM("QSshared\View.cpp", ViewDlg);
USEUNIT("QSshared\HeadMan.cpp");
USEUNIT("QSshared\FileMan.cpp");
USEUNIT("QSshared\nymmail.cpp");
USEUNIT("QSshared\tbuffer.cpp");
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall NymInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, HWND AppHandle);
extern "C" __declspec(dllexport) void __fastcall NymShutDown();
extern "C" __declspec(dllexport) char*__fastcall GetNymLibVersion();
extern "C" __declspec(dllexport) char*__fastcall GetNymLibName();
extern "C" __declspec(dllexport) bool __fastcall RunNymWizard(TForm *Owner);
extern "C" __declspec(dllexport) void __fastcall RunNymWizardExe();
extern "C" __declspec(dllexport) void __fastcall RunNymReports(TForm *Owner);
extern "C" __declspec(dllexport) void __fastcall RunFinger(TForm *Owner);
extern "C" __declspec(dllexport) char*__fastcall DecryptNymMessage(TForm *Owner,
   char *msg, int &errcode);
//---------------------------------------------------------------------------
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}
//---------------------------------------------------------------------------
void __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
}
//---------------------------------------------------------------------------
void __fastcall NymShutDown()
{
   if (NymWizDlg) delete NymWizDlg;
   if (retbuf) delete retbuf;
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode)
{
   TStringList *msg = new TStringList();
   msg->SetText(message);
   if (retbuf) delete retbuf; retbuf = NULL;
   TNymDecDlg *NymDecDlg = new TNymDecDlg(Owner);
   if (NymDecDlg->Decrypt(msg))
   {
      retbuf = new char[msg->Text.Length()+1];
      strcpy(retbuf,msg->Text.c_str());
   }
   errcode = NymDecDlg->errcode;
   delete NymDecDlg;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall RunNymWizard(TForm *Owner)
{
   if (NymWizDlg)
   {
      NymWizDlg->BringToFront();
      return true;
   }
   bool run = false;
   NymWizDlg = new TNymWizDlg(Owner);
   CenterDialog(NymWizDlg,Owner);
   NymWizDlg->Label17->Caption = "";
   NymWizDlg->ShowModal();
   if (NymWizDlg->ModalResult==mrOk)
      run = true;
   delete NymWizDlg;
   return run;
}
//---------------------------------------------------------------------------
void __fastcall RunNymWizardExe()
{
   AnsiString mixdir;
   TRegistry *reg = new TRegistry();
   if (reg->OpenKey(MixKey,false) && reg->ValueExists("mixdir"))
      mixdir = reg->ReadString("mixdir");
   delete reg;

   hSSLLib = LoadLibrary(s(AddBS(mixdir)+"libeay32.dll").c_str());
   hMixLib = LoadLibrary(s(AddBS(mixdir)+"mixlib.dll").c_str());
   //TForm *owner=NULL;
   //HWND hwndowner = FindWindow("TQSMainWin",NULL);
   //if (hwndowner) owner = (TForm*)SendMessage(hwndowner,WM_NYMWIZHERE,0,(LPARAM)NULL);
   //if (owner) CenterDialog(NymWizDlg,owner);
   NymWizDlg = new TNymWizDlg(NULL);
   NymWizDlg->ShowModal();
   delete NymWizDlg;

   FreeLibrary(hMixLib);
   FreeLibrary(hSSLLib);
}
//---------------------------------------------------------------------------
void __fastcall RunNymReports(TForm *Owner)
{
   NymRptsDlg = new TNymRptsDlg(Owner);
   NymRptsDlg->ShowModal();
   delete NymRptsDlg;
}
//---------------------------------------------------------------------------
void __fastcall RunFinger(TForm *Owner)
{
   FingerDlg = new TFingerDlg(Owner);
   CenterDialog(FingerDlg,Owner);
   FingerDlg->ShowModal();
   delete FingerDlg;
}
//---------------------------------------------------------------------------
